=== modified file 'lib/lp/bugs/scripts/tests/test_bugimport.py'
--- lib/lp/bugs/scripts/tests/test_bugimport.py	2011-12-30 06:14:56 +0000
+++ lib/lp/bugs/scripts/tests/test_bugimport.py	2012-01-05 00:15:32 +0000
@@ -1,4 +1,4 @@
-# Copyright 2009-2011 Canonical Ltd.  This software is licensed under the
+# Copyright 2009-2012 Canonical Ltd.  This software is licensed under the
 # GNU Affero General Public License version 3 (see the file LICENSE).
 
 import os
@@ -282,7 +282,7 @@
         transaction.commit()
         self.failIf(person.account is None, 'Person must have an account.')
         email = getUtility(IEmailAddressSet).new(
-            'foo@preferred.com', person, account=person.account)
+            'foo@preferred.com', person)
         person.setPreferredEmail(email)
         transaction.commit()
         self.assertEqual(person.preferredemail.email, 'foo@preferred.com')

=== modified file 'lib/lp/code/scripts/tests/test_revisionkarma.py'
--- lib/lp/code/scripts/tests/test_revisionkarma.py	2012-01-01 02:58:52 +0000
+++ lib/lp/code/scripts/tests/test_revisionkarma.py	2012-01-05 00:15:32 +0000
@@ -1,4 +1,4 @@
-# Copyright 2009-2011 Canonical Ltd.  This software is licensed under the
+# Copyright 2009-2012 Canonical Ltd.  This software is licensed under the
 # GNU Affero General Public License version 3 (see the file LICENSE).
 
 """Tests for the cron script that updates revision karma."""
@@ -104,7 +104,7 @@
 
         # Now link the revision author to the author.
         author.validateAndEnsurePreferredEmail(
-            EmailAddressSet().new(email, author, account=author.account))
+            EmailAddressSet().new(email, author))
         transaction.commit()
         # Run the RevisionAuthorEmailLinker garbo job.
         RevisionAuthorEmailLinker(log=DevNullLogger()).run()

=== modified file 'lib/lp/hardwaredb/doc/hwdb.txt'
--- lib/lp/hardwaredb/doc/hwdb.txt	2011-12-18 13:45:20 +0000
+++ lib/lp/hardwaredb/doc/hwdb.txt	2012-01-04 23:49:46 +0000
@@ -408,7 +408,7 @@
 the field `owner` is updated.
 
     >>> email = getUtility(IEmailAddressSet).new(
-    ...     u'beeblebrox@beeblebrox.net', user, account=user.account)
+    ...     u'beeblebrox@beeblebrox.net', user)
     >>> transaction.commit()
     >>> login_person(user)
     >>> user.validateAndEnsurePreferredEmail(email)

=== modified file 'lib/lp/registry/doc/mailinglist-subscriptions-xmlrpc.txt'
--- lib/lp/registry/doc/mailinglist-subscriptions-xmlrpc.txt	2011-12-30 08:03:42 +0000
+++ lib/lp/registry/doc/mailinglist-subscriptions-xmlrpc.txt	2012-01-04 23:49:46 +0000
@@ -143,8 +143,7 @@
 
     >>> from lp.services.identity.interfaces.emailaddress import IEmailAddressSet
     >>> emailset = getUtility(IEmailAddressSet)
-    >>> new_address = emailset.new(
-    ...     'frederick@example.com', fred, account=fred.account)
+    >>> new_address = emailset.new('frederick@example.com', fred)
     >>> new_address.email, new_address.status.title
     (u'frederick@example.com', 'New Email Address')
     >>> sorted((email_address.email, email_address.status.title)
@@ -279,7 +278,7 @@
     >>> from lp.services.identity.interfaces.emailaddress import EmailAddressStatus
     >>> new_address = emailset.new(
     ...     config.mailman.archive_address, fred,
-    ...     EmailAddressStatus.VALIDATED, account=fred.account)
+    ...     EmailAddressStatus.VALIDATED)
     >>> transaction.commit()
 
     >>> mailinglist_api.isRegisteredInLaunchpad(

=== modified file 'lib/lp/registry/doc/mailinglist-subscriptions.txt'
--- lib/lp/registry/doc/mailinglist-subscriptions.txt	2012-01-04 22:30:45 +0000
+++ lib/lp/registry/doc/mailinglist-subscriptions.txt	2012-01-04 23:49:46 +0000
@@ -125,7 +125,7 @@
     >>> from lp.services.identity.interfaces.emailaddress import IEmailAddressSet
     >>> address_set = getUtility(IEmailAddressSet)
     >>> alternative = address_set.new(
-    ...     'anne.x.person@example.net', anne, account=anne.account)
+    ...     'anne.x.person@example.net', anne)
     >>> alternative.email
     u'anne.x.person@example.net'
 
@@ -246,7 +246,7 @@
 to post to the mailing list.
 
     >>> alternative = address_set.new(
-    ...     'cris.x.person@example.net', cris, account=cris.account)
+    ...     'cris.x.person@example.net', cris)
     >>> alternative.email
     u'cris.x.person@example.net'
 

=== modified file 'lib/lp/registry/doc/person.txt'
--- lib/lp/registry/doc/person.txt	2011-12-30 07:38:46 +0000
+++ lib/lp/registry/doc/person.txt	2012-01-04 23:49:46 +0000
@@ -158,7 +158,7 @@
 
     >>> emailset = getUtility(IEmailAddressSet)
     >>> validated_email = emailset.new(
-    ...     'validated@canonical.com', p, account=p.account)
+    ...     'validated@canonical.com', p)
     >>> validated_email.status
     <DBItem EmailAddressStatus.NEW...
 
@@ -171,7 +171,7 @@
 setPreferredEmail() method updated the address's status.
 
     >>> preferred_email = emailset.new(
-    ...     'preferred@canonical.com', p, account=p.account)
+    ...     'preferred@canonical.com', p)
     >>> preferred_email.status
     <DBItem EmailAddressStatus.NEW...
 

=== modified file 'lib/lp/registry/stories/person/merge-people.txt'
--- lib/lp/registry/stories/person/merge-people.txt	2011-12-20 10:21:46 +0000
+++ lib/lp/registry/stories/person/merge-people.txt	2012-01-04 23:49:46 +0000
@@ -30,8 +30,7 @@
     >>> foo = PersonSet().getByName('foo')
     >>> email = EmailAddressSet().new(
     ...     'bar.foo@canonical.com', person=foo,
-    ...     status=EmailAddressStatus.VALIDATED,
-    ...     account=foo.account)
+    ...     status=EmailAddressStatus.VALIDATED)
 
 Then we find the duplicate account and request the merge.
 This redirects to the page which displays all email addresses owned by the

=== modified file 'lib/lp/registry/tests/test_person.py'
--- lib/lp/registry/tests/test_person.py	2011-12-30 06:14:56 +0000
+++ lib/lp/registry/tests/test_person.py	2012-01-05 03:11:37 +0000
@@ -1,4 +1,4 @@
-# Copyright 2009-2011 Canonical Ltd.  This software is licensed under the
+# Copyright 2009-2012 Canonical Ltd.  This software is licensed under the
 # GNU Affero General Public License version 3 (see the file LICENSE).
 
 __metaclass__ = type
@@ -1243,8 +1243,7 @@
         self.identifier = self.makeOpenIdIdentifier(self.account, u'whatever')
         self.person = self.makePerson(self.account)
         self.email = self.makeEmailAddress(
-            email='whatever@example.com',
-            account=self.account, person=self.person)
+            email='whatever@example.com', person=self.person)
 
     def makeAccount(self):
         return self.store.add(Account(
@@ -1264,10 +1263,10 @@
             displayname='Displayname',
             creation_rationale=PersonCreationRationale.UNKNOWN))
 
-    def makeEmailAddress(self, email, account, person):
+    def makeEmailAddress(self, email, person):
             return self.store.add(EmailAddress(
                 email=email,
-                account=account,
+                account=person.account,
                 person=person,
                 status=EmailAddressStatus.PREFERRED))
 

=== modified file 'lib/lp/services/identity/doc/emailaddress.txt'
--- lib/lp/services/identity/doc/emailaddress.txt	2011-12-18 13:45:20 +0000
+++ lib/lp/services/identity/doc/emailaddress.txt	2012-01-04 23:49:46 +0000
@@ -35,14 +35,14 @@
 
     >>> personset = getUtility(IPersonSet)
     >>> foobar = personset.getByName('name16')
-    >>> emailset.new(email.email, foobar, account=foobar.account)
+    >>> emailset.new(email.email, foobar)
     Traceback (most recent call last):
     ...
     EmailAddressAlreadyTaken: The email address '...' is already registered.
 
 The email address verification is case insensitive as well:
 
-    >>> emailset.new(email.email.upper(), foobar, account=foobar.account)
+    >>> emailset.new(email.email.upper(), foobar)
     Traceback (most recent call last):
     ...
     EmailAddressAlreadyTaken: The email address '...' is already registered.
@@ -50,7 +50,7 @@
 Registering a new email address works -- and preserves case -- though:
 
     >>> emailaddress = emailset.new(
-    ...     'oink@Canonical.com', foobar, account=foobar.account)
+    ...     'oink@Canonical.com', foobar)
     >>> emailaddress.email
     u'oink@Canonical.com'
 

=== modified file 'lib/lp/services/identity/interfaces/emailaddress.py'
--- lib/lp/services/identity/interfaces/emailaddress.py	2011-12-24 16:54:44 +0000
+++ lib/lp/services/identity/interfaces/emailaddress.py	2012-01-05 00:15:32 +0000
@@ -1,4 +1,4 @@
-# Copyright 2009-2011 Canonical Ltd.  This software is licensed under the
+# Copyright 2009-2012 Canonical Ltd.  This software is licensed under the
 # GNU Affero General Public License version 3 (see the file LICENSE).
 
 # pylint: disable-msg=E0211,E0213
@@ -135,7 +135,8 @@
         """Create a new EmailAddress with the given email.
 
         The newly created EmailAddress will point to the person
-        and/or account.
+        and/or account. If account is omitted and the person has a linked
+        account, that account will be used.
 
         The given status must be an item of EmailAddressStatus.
 

=== modified file 'lib/lp/services/identity/model/emailaddress.py'
--- lib/lp/services/identity/model/emailaddress.py	2011-12-30 06:14:56 +0000
+++ lib/lp/services/identity/model/emailaddress.py	2012-01-05 00:15:32 +0000
@@ -1,4 +1,4 @@
-# Copyright 2009-2011 Canonical Ltd.  This software is licensed under the
+# Copyright 2009-2012 Canonical Ltd.  This software is licensed under the
 # GNU Affero General Public License version 3 (see the file LICENSE).
 
 # pylint: disable-msg=E0611,W0212
@@ -132,6 +132,8 @@
         if person is None:
             personID = None
         else:
+            if account is None:
+                account = person.account
             personID = person.id
             accountID = account and account.id
             assert person.accountID == accountID, (

=== modified file 'lib/lp/services/mailman/doc/subscriptions.txt'
--- lib/lp/services/mailman/doc/subscriptions.txt	2011-12-24 15:18:32 +0000
+++ lib/lp/services/mailman/doc/subscriptions.txt	2012-01-04 23:49:46 +0000
@@ -110,8 +110,7 @@
     >>> from lp.services.identity.interfaces.emailaddress import IEmailAddressSet
     >>> login('admin@canonical.com')
     >>> email_set = getUtility(IEmailAddressSet)
-    >>> email = email_set.new(
-    ...     'anne.x.person@example.net', anne, account=anne.account)
+    >>> email = email_set.new('anne.x.person@example.net', anne)
     >>> transaction.commit()
     >>> helpers.ensure_membership('itest-one', anne)
 
@@ -160,8 +159,7 @@
 
     >>> login('admin@canonical.com')
     >>> emma = factory.makePersonByName('Emma')
-    >>> email = email_set.new(
-    ...     'EmmaXPerson@example.org', emma, account=emma.account)
+    >>> email = email_set.new('EmmaXPerson@example.org', emma)
     >>> email.status = EmailAddressStatus.VALIDATED
     >>> transaction.commit()
     >>> from lp.registry.interfaces.mailinglist import IMailingListSet

=== modified file 'lib/lp/services/verification/browser/logintoken.py'
--- lib/lp/services/verification/browser/logintoken.py	2011-12-30 06:14:56 +0000
+++ lib/lp/services/verification/browser/logintoken.py	2012-01-05 00:15:32 +0000
@@ -1,4 +1,4 @@
-# Copyright 2009-2011 Canonical Ltd.  This software is licensed under the
+# Copyright 2009-2012 Canonical Ltd.  This software is licensed under the
 # GNU Affero General Public License version 3 (see the file LICENSE).
 
 __metaclass__ = type
@@ -441,7 +441,7 @@
         validated = (
             EmailAddressStatus.VALIDATED, EmailAddressStatus.PREFERRED)
         requester = self.context.requester
-        account = self.context.requester_account
+        account = requester.account
 
         emailset = getUtility(IEmailAddressSet)
         email = emailset.getByEmail(self.context.email)
@@ -518,13 +518,12 @@
         if email is None:
             email = emailset.new(
                 email=self.context.email,
-                person=self.context.requester,
-                account=self.context.requester_account)
+                person=self.context.requester)
         return email
 
     def markEmailAsValid(self, email):
         """Mark the given email address as valid."""
-        self.context.requester_account.validateAndEnsurePreferredEmail(email)
+        self.context.requester.account.validateAndEnsurePreferredEmail(email)
 
 
 class ValidateTeamEmailView(ValidateEmailView):

=== modified file 'lib/lp/services/verification/interfaces/authtoken.py'
--- lib/lp/services/verification/interfaces/authtoken.py	2011-12-24 16:54:44 +0000
+++ lib/lp/services/verification/interfaces/authtoken.py	2012-01-05 00:15:32 +0000
@@ -1,4 +1,4 @@
-# Copyright 2009 Canonical Ltd.  This software is licensed under the
+# Copyright 2009-2012 Canonical Ltd.  This software is licensed under the
 # GNU Affero General Public License version 3 (see the file LICENSE).
 
 # pylint: disable-msg=E0211,E0213
@@ -154,8 +154,6 @@
     requester = Int(
         title=_('The Person that made this request.'), required=True,
         )
-    requester_account = Int(
-        title=_('The account that made this request.'), required=True)
     requesteremail = Text(
         title=_('The email address that was used to login when making this '
                 'request.'),

=== modified file 'lib/lp/services/verification/model/logintoken.py'
--- lib/lp/services/verification/model/logintoken.py	2011-12-30 06:14:56 +0000
+++ lib/lp/services/verification/model/logintoken.py	2012-01-05 00:15:32 +0000
@@ -1,4 +1,4 @@
-# Copyright 2009-2011 Canonical Ltd.  This software is licensed under the
+# Copyright 2009-2012 Canonical Ltd.  This software is licensed under the
 # GNU Affero General Public License version 3 (see the file LICENSE).
 
 # pylint: disable-msg=E0611,W0212
@@ -30,7 +30,6 @@
 from lp.services.database.constants import UTC_NOW
 from lp.services.database.datetimecol import UtcDateTimeCol
 from lp.services.database.enumcol import EnumCol
-from lp.services.database.lpstorm import IMasterObject
 from lp.services.database.sqlbase import (
     SQLBase,
     sqlvalues,
@@ -78,13 +77,6 @@
 
     title = 'Launchpad Email Verification'
 
-    @property
-    def requester_account(self):
-        """See `ILoginToken`."""
-        if self.requester is None or self.requester.account is None:
-            return None
-        return IMasterObject(self.requester.account)
-
     def consume(self):
         """See ILoginToken."""
         self.date_consumed = UTC_NOW
@@ -257,8 +249,7 @@
     def activateGPGKey(self, key, can_encrypt):
         """See `ILoginToken`."""
         gpgkeyset = getUtility(IGPGKeySet)
-        requester = self.requester
-        lpkey, new = gpgkeyset.activate(requester, key, can_encrypt)
+        lpkey, new = gpgkeyset.activate(self.requester, key, can_encrypt)
 
         self.consume()
 
@@ -280,7 +271,6 @@
         """
         emailset = getUtility(IEmailAddressSet)
         requester = self.requester
-        account = self.requester_account
         emails = chain(requester.validatedemails, [requester.preferredemail])
         # Must remove the security proxy because the user may not be logged in
         # and thus won't be allowed to view the requester's email addresses.
@@ -304,7 +294,7 @@
                 else:
                     # The email is not yet registered, so we register it for
                     # our user.
-                    email = emailset.new(uid, requester, account=account)
+                    email = emailset.new(uid, requester)
                     created.append(uid)
 
         return created, existing_and_owned_by_others

=== modified file 'lib/lp/testing/factory.py'
--- lib/lp/testing/factory.py	2012-01-03 08:53:13 +0000
+++ lib/lp/testing/factory.py	2012-01-04 23:49:46 +0000
@@ -768,8 +768,6 @@
         """
         if email_status is None:
             email_status = EmailAddressStatus.VALIDATED
-        if account is None:
-            account = person.account
         return getUtility(IEmailAddressSet).new(
             address, person, email_status, account)
 

